unit Irhelper;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SLINKXLib_TLB;

type
  TForm1 = class(TForm)
    Slinkx1: TSlinkx;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Slinkx1SlinkeDeviceEvent(Sender: TObject; var Device,
      Message: WideString);
    procedure SimulateKeyDown(Key : byte);
    procedure SimulateKeyUp(Key : byte);
    procedure SimulateKeystroke(Key : byte; extra : DWORD);
    procedure SendKeys(s : string);
    procedure SendKeysVK(i : integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


  var
  Form1: TForm1;
  DVD_app_hwnd : Integer  ;
  DVD_app_class : PChar ;
  DVD_app_name : PChar ;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   Slinkx1.AddDevice('sonydvd', 'Sonydvd.cde', 1, 1, $FFF) ;
   Slinkx1.ReportNoMatch := 0 ;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   Slinkx1.DeleteDevice('sonydvd') ;
end;

procedure TForm1.Slinkx1SlinkeDeviceEvent(Sender: TObject; var Device,
  Message: WideString);
// The 'Device' and 'Message' parameters are sent by the Slinke event.
// You just have to respond to the event you want.
begin
   // Shift the lines of the multiple text fields up so they scroll.
   // Use these because a single large memo will hog memory eventually.
   Edit1.Text := Edit2.Text ;
   Edit2.Text := Edit3.Text ;
   Edit3.Text := Edit4.Text ;
   Edit4.Text := Edit5.Text ;
   Edit5.Text := Edit6.Text ;
   Edit6.Text := (Device + ':' + Message) ;

   //  Use multiple if statements because CASE statement doesn't
   //  work with strings.  Next version will place these in a list
   //  and use pointers.
   If Device = 'sonydvd' Then Begin	// Don't recurse these if not SonyDVD.
      If message = 'power'            then Sendkeys('E') ;
      If message = 'enter'            then SendkeysVK(VK_RETURN) ;
      If message = 'play'             then Sendkeys('P') ;
      If message = 'stop'             then Sendkeys('S') ;
      If message = 'pause'            then Sendkeys('A') ;
      If message = 'next'             then Sendkeys('N') ;
      If message = 'previous'         then Sendkeys('V') ;
//    If message = 'display'          then Sendkeys('') ;
      If message = 'title'            then Sendkeys('T') ;
      If message = 'menu'             then Sendkeys('M') ;
      If message = 'dvd_menu'         then Sendkeys('M') ;
      If message = 'clear'            then Sendkeys('') ;
      If message = 'return'           then SendkeysVK(VK_RETURN) ;
      If message = 'search'           then Sendkeys('') ;
      If message = 'sub-title_change' then Sendkeys('') ;
      If message = 'sub-title_on_off' then Sendkeys('') ;
      If message = 'audio_change'     then SendkeysVK(VK_F3) ;
      If message = 'fast_forward'     then Sendkeys('F') ;
      If message = 'fast_rewind'      then Sendkeys('R') ;
      If message = 'cursor_left'      then SendkeysVK(VK_LEFT) ;
      If message = 'cursor_right'     then SendkeysVK(VK_RIGHT) ;
      If message = 'cursor_up'        then SendkeysVK(VK_UP) ;
      If message = 'cursor_down'      then SendkeysVK(VK_DOWN) ;
      If message = '1'                then SendkeysVK(VK_NUMPAD1) ;
      If message = '2'                then SendkeysVK(VK_NUMPAD2) ;
      If message = '3'                then SendkeysVK(VK_NUMPAD3) ;
      If message = '4'                then SendkeysVK(VK_NUMPAD4) ;
      If message = '5'                then SendkeysVK(VK_NUMPAD5) ;
      If message = '6'                then SendkeysVK(VK_NUMPAD6) ;
      If message = '7'                then SendkeysVK(VK_NUMPAD7) ;
      If message = '8'                then SendkeysVK(VK_NUMPAD8) ;
      If message = '9'                then SendkeysVK(VK_NUMPAD9) ;
      If message = '0'                then SendkeysVK(VK_NUMPAD0) ;
   end;
end;


procedure TForm1.SimulateKeyDown(Key : byte);
begin
   keybd_event(Key, 0, 0, 0);
end;

procedure TForm1.SimulateKeyUp(Key : byte);
begin
   keybd_event(Key, 0, KEYEVENTF_KEYUP, 0);
end;

procedure TForm1.SimulateKeystroke(Key : byte; extra : DWORD);
begin
keybd_event(Key,
            extra,
            0,
            0);
keybd_event(Key,
            extra,
            KEYEVENTF_KEYUP,
            0);
end;

procedure TForm1.SendKeys(s : string);
var
   i : integer;
   flag : bool;
   w : word;
begin
   // Getting the handle could be done globally (once) except I wanted it here
   // in case the DVD app wasn't up and running when the IRHelper app started.

   // Set variables for class name and application name.
   DVD_app_class := 'PlayWnd';
   DVD_app_name := 'Creative PC-DVD Player';

   // Get handle to the window in question.
   DVD_app_hwnd := FindWindow(dvd_app_class, dvd_app_name) ;

   // Set window as foreground by using obtained handle.
   // This really could use some error checking in case the window doesn't exist.
   // Maybe next version will launch DVD player if not already running.
   Windows.SetForegroundWindow(dvd_app_hwnd);

// Get the state of the caps lock key.
flag := not GetKeyState(VK_CAPITAL) and 1 = 0;

// If the caps lock key is on then turn it off.
if flag then SimulateKeystroke(VK_CAPITAL, 0);

// Cycle through character string sending each keystroke.
for i := 1 to Length(s) do begin
   w := VkKeyScan(s[i]);
   // If there is not an error in the key translation.
   if ((HiByte(w) <> $FF) and (LoByte(w) <> $FF)) then
      begin
         // If the key requires the shift key down - hold it down.
         if HiByte(w) and 1 = 1 then SimulateKeyDown(VK_SHIFT);
         // Send the VK_KEY
         SimulateKeystroke(LoByte(w), 0);
         // If the key required the shift key down - release it.
         if HiByte(w) and 1 = 1 then SimulateKeyUp(VK_SHIFT);
      end;
end;  //endfor
// if the caps lock key was on at start, turn it back on.
if flag then SimulateKeystroke(VK_CAPITAL, 0);
end;


// The procedure is really the same as the previous one except it
// is used for single VK keys - not strings that have to be converted.
procedure TForm1.SendKeysVK(i : integer);
var
   flag : bool;
   w : word;
begin
   // Getting the handle could be done globally (once) except I wanted it here
   // in case the DVD app wasn't up and running when the IRHelper app started.

   // Set variables for class name and application name.
   DVD_app_class := 'PlayWnd';
   DVD_app_name := 'Creative PC-DVD Player';

   // Get handle to the window in question.
   DVD_app_hwnd := FindWindow(dvd_app_class, dvd_app_name) ;

   // Set window as foreground by using obtained handle.
   // This really could use some error checking in case the window doesn't exist.
   // Maybe next version will launch DVD player if not already running.
   Windows.SetForegroundWindow(dvd_app_hwnd);


// Get the state of the caps lock key.
flag := not GetKeyState(VK_CAPITAL) and 1 = 0;

// If the caps lock key is on then turn it off.
if flag then SimulateKeystroke(VK_CAPITAL, 0);
   w := i;
   // If there is not an error in the key translation
   if ((HiByte(w) <> $FF) and (LoByte(w) <> $FF)) then
      begin
         // If the key requires the shift key down - hold it down.
         if HiByte(w) and 1 = 1 then SimulateKeyDown(VK_SHIFT);
         // Send the VK_KEY.
         SimulateKeystroke(LoByte(w), 0);
         // If the key required the shift key down - release it.
         if HiByte(w) and 1 = 1 then SimulateKeyUp(VK_SHIFT);
      end;
// if the caps lock key was on at start, turn it back on.
if flag then SimulateKeystroke(VK_CAPITAL, 0);
end;



end.
